<template>
	<div v-if="step > 0" :class="$style.globalCartPanelUpsell">
		<div :class="$style.progress">
			<span :class="$style.progressBar" :style="{ width: `${50 * step}%` }" />
			<div>
				<span :class="$style.activeDot" />
				<span :class="step >= 1 ? $style.activeDot : $style.dot" />
				<span :class="step >= 2 ? $style.activeDot : $style.dot" />
			</div>
		</div>
		<div :class="$style.message">{{ message }}</div>
	</div>
	<h2 v-else class="u-font-secondary" :class="$style.defaultText">The clean air you deserve.</h2>
</template>

<script>
import { mapState, mapGetters } from 'vuex';

export default {
	props: {
		cartItems: {
			type: Array,
			required: true,
		},

		cartDiscount: {
			type: Number,
			required: true,
		},
	},

	computed: {
		...mapGetters('magento', ['cart']),
		...mapGetters(['currencySymbol']),
		...mapState('magento', ['upsells']),

		activeUpsell() {
			const { upsells, cartItems } = this;
			const upsellsWithOneProduct = upsells.filter((upsell) => upsell.items.length === 1);
			let activeUpsell;

			for (let i = 0; i < upsellsWithOneProduct.length; i++) {
				const upsell = upsellsWithOneProduct[i];

				const areCartItemsInUpsell = cartItems.every((cartItem) =>
					upsell.items.some((upsellItem) => upsellItem.sku === cartItem.sku && upsellItem.qty >= cartItem.qty)
				);

				if (areCartItemsInUpsell) {
					activeUpsell = {
						...upsell,
						discount: Math.ceil(Math.abs(upsell.discount)),
					};
					break;
				} else {
					continue;
				}
			}

			return activeUpsell;
		},

		isActiveUpsellFulfilled() {
			const { cartItems, activeUpsell } = this;
			return (
				cartItems.length === activeUpsell.items.length &&
				activeUpsell.items.every((upsellItem) =>
					cartItems.some((cartItem) => cartItem.sku === upsellItem.sku && cartItem.qty === upsellItem.qty)
				)
			);
		},

		step() {
			return !this.activeUpsell ? 0 : !this.isActiveUpsellFulfilled ? 1 : 2;
		},

		message() {
			const { currencySymbol, activeUpsell, cartItems } = this;
			let message = '';
			switch (this.step) {
				case 1: {
					const missingProducts = activeUpsell.items.reduce((missingProducts, { sku, qty, name }) => {
						const foundCartItem = cartItems.find((cartItem) => cartItem.sku === sku);

						if (!foundCartItem || foundCartItem.qty < qty) {
							missingProducts[sku] = {
								qty: qty - (foundCartItem ? foundCartItem.qty : 0),
								name,
							};
						}

						return missingProducts;
					}, {});

					const missingProductsStrings = Object.entries(missingProducts).reduce((final, [sku, { qty, name }]) => {
						final.push(`${qty} ${name.replace('Molekule', '')}${qty > 1 ? 's' : ''}`);
						return final;
					}, []);

					const missingProductsString =
						missingProductsStrings.lenth > 1
							? `${missingProductsStrings.slice(0, -1).join(', ')} and ${
									missingProductsStrings[missingProductsStrings.length - 1]
							  }`
							: missingProductsStrings[0];

					message = `You're ${missingProductsString} away from saving ${currencySymbol}${this.activeUpsell.discount}.`;
					break;
				}
				case 2:
					message = `Congrats! You saved ${currencySymbol}${this.cartDiscount}.`;
			}

			return message;
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

$dot-diameter: 1.7rem;

.globalCartPanelUpsell {
	padding: 3rem 0 0.9rem;
}

.progress {
	position: relative;
	width: calc(100% - #{$dot-diameter});
	height: 0.08rem;
	margin: 0 auto 2.9rem;
	background: color('primary-250');
}

.progressBar {
	position: absolute;
	top: 0;
	left: 0;
	display: block;
	width: 50%;
	height: 0.3rem;
	background: color('secondary');
	transition: width time('fast') ease-out;
	transform: translate(0, calc(-50% + 0.04rem));
}

.dot {
	@include square($dot-diameter);

	position: absolute;
	top: 0;
	background: color('white');
	border: 0.1rem solid color('primary-250');
	border-radius: 50%;
	transform: translate(-50%, calc(-50% + 0.04rem));

	&:first-child {
		left: 0;
	}

	&:nth-child(2) {
		left: 50%;
	}

	&:last-child {
		left: 100%;
	}
}

.activeDot {
	composes: dot;
	background: color('secondary');
	border-color: color('secondary');
}

.message {
	@include use-text-style('type-500');

	margin: 1em auto;
	font-family: font-family('secondary');
}

.defaultText {
	@include use-text-style('heading-200');

	margin-top: size('m') - size('s');
	margin-bottom: size('m') - size('s');
}
</style>
